import es
import cPickle
import installlib
import datetime
import threading

from __future__ import division


#This addon ONLY supports bans by STEAMID!

info = es.AddonInfo()
info.name = "bansaver"
info.author = "Brainsucker"
info.description = "Saves NON-Permanent bans. So the bans will not expire at a server restart."
info.url = "http://addons.eventscripts.com/addons/view/bansaver"
info.version = "1.2.6"


def updatecheck():
	installer = installlib.getInstaller('bansaver')
	
	if not installer.isInstalled():
		# It seems the Addon has not been installed correnctly. So we will run the install() function once again to provide correct installation.
		installer.install()
	
	
	us = installer.update()
	if us == installer.STATUS_SUCCESSFUL:
		es.dbgmsg(0, '[BANSAVER] Successfully Updated!')
		es.reload('bansaver')
			
def saveDB():
	threading.Thread(target=cPickle.dump, args=(bandict, open(addonpath + "/banned_user.db", "wb"))).start()
			
			
addonpath = es.getAddonPath(info["name"])
bandict = {}
bandict["steamids"] = {}
expired = set()
td = datetime.datetime.today()
try:
	bandict = cPickle.load(open(addonpath + "/banned_user.db", "rb"))
except:
	pass
else:
	for b in bandict["steamids"].keys():
		remaining_bantime = bandict['steamids'][b]['expiredate']- td
		remaining_days = remaining_bantime.days
		remaining_seconds = remaining_bantime.seconds + (remaining_days*86400)
		remaining_minutes = remaining_seconds/60
		if remaining_minutes > 0:
			es.server.queuecmd("banid %f %s" % (remaining_minutes, b))
			
		else:
			expired.add(b)
			
	for s in expired:
		del bandict['steamids'][s]
		
	saveDB()

if es.getplayercount() == 0:
	updatecheck()
es.ServerVar(info["name"], info["version"]).makepublic()

def es_map_start(ev):
	updatecheck()


def server_addban(ev):
	steamid = ev["networkid"]
	dur = ev["duration"]
	if dur != "permanently":
		bt_float = str(dur).split()[1]
		bantime = float(bt_float)
		if bantime > 0:
			if not bandict['steamids'].has_key(steamid):
				bandict["steamids"][steamid] = {}
			today = datetime.datetime.today()
			ed = datetime.timedelta(minutes=bantime) + today
			
			
			bandict['steamids'][steamid]['expiredate'] = ed
			saveDB()
				
	
def server_removeban(ev):
	steamid = ev["networkid"]
	if bandict["steamids"].has_key(steamid):
		del bandict["steamids"][steamid]
		
	saveDB()